
_main:

;Snake.c,60 :: 		void main() {
;Snake.c,62 :: 		ADCON1=0x06;
	MOVLW       6
	MOVWF       ADCON1+0 
;Snake.c,63 :: 		TRISA=0xFF;
	MOVLW       255
	MOVWF       TRISA+0 
;Snake.c,64 :: 		TRISB=0x00;
	CLRF        TRISB+0 
;Snake.c,65 :: 		TRISC=0x00;
	CLRF        TRISC+0 
;Snake.c,66 :: 		TRISD=0x00;
	CLRF        TRISD+0 
;Snake.c,67 :: 		TRISE=0x00;
	CLRF        TRISE+0 
;Snake.c,69 :: 		Init_Game();
	CALL        _Init_Game+0, 0
;Snake.c,70 :: 		Level = 500;
	MOVLW       244
	MOVWF       _Level+0 
	MOVLW       1
	MOVWF       _Level+1 
;Snake.c,72 :: 		while(1) {
L_main0:
;Snake.c,74 :: 		LATC=0;
	CLRF        LATC+0 
;Snake.c,75 :: 		LATD=0;
	CLRF        LATD+0 
;Snake.c,76 :: 		Display_X=Display_X<<1;
	MOVF        LATB+0, 0 
	MOVWF       R0 
	RLCF        R0, 1 
	BCF         R0, 0 
	MOVF        R0, 0 
	MOVWF       LATB+0 
;Snake.c,77 :: 		Display_X.F0=C_Bit;
	BTFSC       C_bit+0, 0 
	GOTO        L__main177
	BCF         LATB+0, 0 
	GOTO        L__main178
L__main177:
	BSF         LATB+0, 0 
L__main178:
;Snake.c,79 :: 		Read_Vectorial_Keys();
	CALL        _Read_Vectorial_Keys+0, 0
;Snake.c,80 :: 		Read_Function_Keys();
	CALL        _Read_Function_Keys+0, 0
;Snake.c,82 :: 		++Timer;
	INFSNZ      _Timer+0, 1 
	INCF        _Timer+1, 1 
;Snake.c,83 :: 		if(Timer>=Speed) {
	MOVF        _Speed+1, 0 
	SUBWF       _Timer+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main179
	MOVF        _Speed+0, 0 
	SUBWF       _Timer+0, 0 
L__main179:
	BTFSS       STATUS+0, 0 
	GOTO        L_main2
;Snake.c,85 :: 		Timer=0;
	CLRF        _Timer+0 
	CLRF        _Timer+1 
;Snake.c,86 :: 		Snake_UpDate();
	CALL        _Snake_UpDate+0, 0
;Snake.c,87 :: 		}
L_main2:
;Snake.c,88 :: 		Display_UpDate();
	CALL        _Display_UpDate+0, 0
;Snake.c,90 :: 		delay_ms(1);
	MOVLW       2
	MOVWF       R12, 0
	MOVLW       75
	MOVWF       R13, 0
L_main3:
	DECFSZ      R13, 1, 1
	BRA         L_main3
	DECFSZ      R12, 1, 1
	BRA         L_main3
;Snake.c,91 :: 		}
	GOTO        L_main0
;Snake.c,92 :: 		}
L_end_main:
	GOTO        $+0
; end of _main

_Display_UpDate:

;Snake.c,94 :: 		void Display_UpDate() {
;Snake.c,96 :: 		if(!X0) {
	BTFSC       LATB+0, 0 
	GOTO        L_Display_UpDate4
;Snake.c,98 :: 		for(Ring=0;Ring<Snake_Size;Ring++) {
	CLRF        _Ring+0 
L_Display_UpDate5:
	MOVF        _Snake_Size+0, 0 
	SUBWF       _Ring+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_Display_UpDate6
;Snake.c,100 :: 		if(Snake_X[Ring]==0) Display_Y_Select(Snake_Y[Ring]);
	MOVLW       _Snake_X+0
	MOVWF       FSR0L 
	MOVLW       hi_addr(_Snake_X+0)
	MOVWF       FSR0H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR0L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_Display_UpDate8
	MOVLW       _Snake_Y+0
	MOVWF       FSR0L 
	MOVLW       hi_addr(_Snake_Y+0)
	MOVWF       FSR0H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR0L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Display_Y_Select_Y_Var+0 
	CALL        _Display_Y_Select+0, 0
L_Display_UpDate8:
;Snake.c,101 :: 		if(Food_X==0 && Food_Show) Display_Y_Select(Food_Y);
	MOVLW       0
	XORWF       _Food_X+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Display_UpDate181
	MOVLW       0
	XORWF       _Food_X+0, 0 
L__Display_UpDate181:
	BTFSS       STATUS+0, 2 
	GOTO        L_Display_UpDate11
	BTFSS       _Food_Show+0, BitPos(_Food_Show+0) 
	GOTO        L_Display_UpDate11
L__Display_UpDate165:
	MOVF        _Food_Y+0, 0 
	MOVWF       FARG_Display_Y_Select_Y_Var+0 
	CALL        _Display_Y_Select+0, 0
L_Display_UpDate11:
;Snake.c,98 :: 		for(Ring=0;Ring<Snake_Size;Ring++) {
	INCF        _Ring+0, 1 
;Snake.c,102 :: 		}
	GOTO        L_Display_UpDate5
L_Display_UpDate6:
;Snake.c,103 :: 		}else if(!X1) {
	GOTO        L_Display_UpDate12
L_Display_UpDate4:
	BTFSC       LATB+0, 1 
	GOTO        L_Display_UpDate13
;Snake.c,105 :: 		for(Ring=0;Ring<Snake_Size;Ring++) {
	CLRF        _Ring+0 
L_Display_UpDate14:
	MOVF        _Snake_Size+0, 0 
	SUBWF       _Ring+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_Display_UpDate15
;Snake.c,107 :: 		if(Snake_X[Ring]==1) Display_Y_Select(Snake_Y[Ring]);
	MOVLW       _Snake_X+0
	MOVWF       FSR0L 
	MOVLW       hi_addr(_Snake_X+0)
	MOVWF       FSR0H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR0L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_Display_UpDate17
	MOVLW       _Snake_Y+0
	MOVWF       FSR0L 
	MOVLW       hi_addr(_Snake_Y+0)
	MOVWF       FSR0H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR0L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Display_Y_Select_Y_Var+0 
	CALL        _Display_Y_Select+0, 0
L_Display_UpDate17:
;Snake.c,108 :: 		if(Food_X==1 && Food_Show) Display_Y_Select(Food_Y);
	MOVLW       0
	XORWF       _Food_X+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Display_UpDate182
	MOVLW       1
	XORWF       _Food_X+0, 0 
L__Display_UpDate182:
	BTFSS       STATUS+0, 2 
	GOTO        L_Display_UpDate20
	BTFSS       _Food_Show+0, BitPos(_Food_Show+0) 
	GOTO        L_Display_UpDate20
L__Display_UpDate164:
	MOVF        _Food_Y+0, 0 
	MOVWF       FARG_Display_Y_Select_Y_Var+0 
	CALL        _Display_Y_Select+0, 0
L_Display_UpDate20:
;Snake.c,105 :: 		for(Ring=0;Ring<Snake_Size;Ring++) {
	INCF        _Ring+0, 1 
;Snake.c,109 :: 		}
	GOTO        L_Display_UpDate14
L_Display_UpDate15:
;Snake.c,110 :: 		}else if(!X2) {
	GOTO        L_Display_UpDate21
L_Display_UpDate13:
	BTFSC       LATB+0, 2 
	GOTO        L_Display_UpDate22
;Snake.c,112 :: 		for(Ring=0;Ring<Snake_Size;Ring++) {
	CLRF        _Ring+0 
L_Display_UpDate23:
	MOVF        _Snake_Size+0, 0 
	SUBWF       _Ring+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_Display_UpDate24
;Snake.c,114 :: 		if(Snake_X[Ring]==2) Display_Y_Select(Snake_Y[Ring]);
	MOVLW       _Snake_X+0
	MOVWF       FSR0L 
	MOVLW       hi_addr(_Snake_X+0)
	MOVWF       FSR0H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR0L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_Display_UpDate26
	MOVLW       _Snake_Y+0
	MOVWF       FSR0L 
	MOVLW       hi_addr(_Snake_Y+0)
	MOVWF       FSR0H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR0L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Display_Y_Select_Y_Var+0 
	CALL        _Display_Y_Select+0, 0
L_Display_UpDate26:
;Snake.c,115 :: 		if(Food_X==2 && Food_Show) Display_Y_Select(Food_Y);
	MOVLW       0
	XORWF       _Food_X+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Display_UpDate183
	MOVLW       2
	XORWF       _Food_X+0, 0 
L__Display_UpDate183:
	BTFSS       STATUS+0, 2 
	GOTO        L_Display_UpDate29
	BTFSS       _Food_Show+0, BitPos(_Food_Show+0) 
	GOTO        L_Display_UpDate29
L__Display_UpDate163:
	MOVF        _Food_Y+0, 0 
	MOVWF       FARG_Display_Y_Select_Y_Var+0 
	CALL        _Display_Y_Select+0, 0
L_Display_UpDate29:
;Snake.c,112 :: 		for(Ring=0;Ring<Snake_Size;Ring++) {
	INCF        _Ring+0, 1 
;Snake.c,116 :: 		}
	GOTO        L_Display_UpDate23
L_Display_UpDate24:
;Snake.c,117 :: 		}else if(!X3) {
	GOTO        L_Display_UpDate30
L_Display_UpDate22:
	BTFSC       LATB+0, 3 
	GOTO        L_Display_UpDate31
;Snake.c,119 :: 		for(Ring=0;Ring<Snake_Size;Ring++) {
	CLRF        _Ring+0 
L_Display_UpDate32:
	MOVF        _Snake_Size+0, 0 
	SUBWF       _Ring+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_Display_UpDate33
;Snake.c,121 :: 		if(Snake_X[Ring]==3) Display_Y_Select(Snake_Y[Ring]);
	MOVLW       _Snake_X+0
	MOVWF       FSR0L 
	MOVLW       hi_addr(_Snake_X+0)
	MOVWF       FSR0H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR0L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_Display_UpDate35
	MOVLW       _Snake_Y+0
	MOVWF       FSR0L 
	MOVLW       hi_addr(_Snake_Y+0)
	MOVWF       FSR0H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR0L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Display_Y_Select_Y_Var+0 
	CALL        _Display_Y_Select+0, 0
L_Display_UpDate35:
;Snake.c,122 :: 		if(Food_X==3 && Food_Show) Display_Y_Select(Food_Y);
	MOVLW       0
	XORWF       _Food_X+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Display_UpDate184
	MOVLW       3
	XORWF       _Food_X+0, 0 
L__Display_UpDate184:
	BTFSS       STATUS+0, 2 
	GOTO        L_Display_UpDate38
	BTFSS       _Food_Show+0, BitPos(_Food_Show+0) 
	GOTO        L_Display_UpDate38
L__Display_UpDate162:
	MOVF        _Food_Y+0, 0 
	MOVWF       FARG_Display_Y_Select_Y_Var+0 
	CALL        _Display_Y_Select+0, 0
L_Display_UpDate38:
;Snake.c,119 :: 		for(Ring=0;Ring<Snake_Size;Ring++) {
	INCF        _Ring+0, 1 
;Snake.c,123 :: 		}
	GOTO        L_Display_UpDate32
L_Display_UpDate33:
;Snake.c,124 :: 		}else if(!X4) {
	GOTO        L_Display_UpDate39
L_Display_UpDate31:
	BTFSC       LATB+0, 4 
	GOTO        L_Display_UpDate40
;Snake.c,126 :: 		for(Ring=0;Ring<Snake_Size;Ring++) {
	CLRF        _Ring+0 
L_Display_UpDate41:
	MOVF        _Snake_Size+0, 0 
	SUBWF       _Ring+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_Display_UpDate42
;Snake.c,128 :: 		if(Snake_X[Ring]==4) Display_Y_Select(Snake_Y[Ring]);
	MOVLW       _Snake_X+0
	MOVWF       FSR0L 
	MOVLW       hi_addr(_Snake_X+0)
	MOVWF       FSR0H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR0L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_Display_UpDate44
	MOVLW       _Snake_Y+0
	MOVWF       FSR0L 
	MOVLW       hi_addr(_Snake_Y+0)
	MOVWF       FSR0H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR0L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Display_Y_Select_Y_Var+0 
	CALL        _Display_Y_Select+0, 0
L_Display_UpDate44:
;Snake.c,129 :: 		if(Food_X==4 && Food_Show) Display_Y_Select(Food_Y);
	MOVLW       0
	XORWF       _Food_X+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Display_UpDate185
	MOVLW       4
	XORWF       _Food_X+0, 0 
L__Display_UpDate185:
	BTFSS       STATUS+0, 2 
	GOTO        L_Display_UpDate47
	BTFSS       _Food_Show+0, BitPos(_Food_Show+0) 
	GOTO        L_Display_UpDate47
L__Display_UpDate161:
	MOVF        _Food_Y+0, 0 
	MOVWF       FARG_Display_Y_Select_Y_Var+0 
	CALL        _Display_Y_Select+0, 0
L_Display_UpDate47:
;Snake.c,126 :: 		for(Ring=0;Ring<Snake_Size;Ring++) {
	INCF        _Ring+0, 1 
;Snake.c,130 :: 		}
	GOTO        L_Display_UpDate41
L_Display_UpDate42:
;Snake.c,131 :: 		}else if(!X5) {
	GOTO        L_Display_UpDate48
L_Display_UpDate40:
	BTFSC       LATB+0, 5 
	GOTO        L_Display_UpDate49
;Snake.c,133 :: 		for(Ring=0;Ring<Snake_Size;Ring++) {
	CLRF        _Ring+0 
L_Display_UpDate50:
	MOVF        _Snake_Size+0, 0 
	SUBWF       _Ring+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_Display_UpDate51
;Snake.c,135 :: 		if(Snake_X[Ring]==5) Display_Y_Select(Snake_Y[Ring]);
	MOVLW       _Snake_X+0
	MOVWF       FSR0L 
	MOVLW       hi_addr(_Snake_X+0)
	MOVWF       FSR0H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR0L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	XORLW       5
	BTFSS       STATUS+0, 2 
	GOTO        L_Display_UpDate53
	MOVLW       _Snake_Y+0
	MOVWF       FSR0L 
	MOVLW       hi_addr(_Snake_Y+0)
	MOVWF       FSR0H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR0L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Display_Y_Select_Y_Var+0 
	CALL        _Display_Y_Select+0, 0
L_Display_UpDate53:
;Snake.c,136 :: 		if(Food_X==5 && Food_Show) Display_Y_Select(Food_Y);
	MOVLW       0
	XORWF       _Food_X+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Display_UpDate186
	MOVLW       5
	XORWF       _Food_X+0, 0 
L__Display_UpDate186:
	BTFSS       STATUS+0, 2 
	GOTO        L_Display_UpDate56
	BTFSS       _Food_Show+0, BitPos(_Food_Show+0) 
	GOTO        L_Display_UpDate56
L__Display_UpDate160:
	MOVF        _Food_Y+0, 0 
	MOVWF       FARG_Display_Y_Select_Y_Var+0 
	CALL        _Display_Y_Select+0, 0
L_Display_UpDate56:
;Snake.c,133 :: 		for(Ring=0;Ring<Snake_Size;Ring++) {
	INCF        _Ring+0, 1 
;Snake.c,137 :: 		}
	GOTO        L_Display_UpDate50
L_Display_UpDate51:
;Snake.c,138 :: 		}else if(!X6) {
	GOTO        L_Display_UpDate57
L_Display_UpDate49:
	BTFSC       LATB+0, 6 
	GOTO        L_Display_UpDate58
;Snake.c,140 :: 		for(Ring=0;Ring<Snake_Size;Ring++) {
	CLRF        _Ring+0 
L_Display_UpDate59:
	MOVF        _Snake_Size+0, 0 
	SUBWF       _Ring+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_Display_UpDate60
;Snake.c,142 :: 		if(Snake_X[Ring]==6) Display_Y_Select(Snake_Y[Ring]);
	MOVLW       _Snake_X+0
	MOVWF       FSR0L 
	MOVLW       hi_addr(_Snake_X+0)
	MOVWF       FSR0H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR0L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L_Display_UpDate62
	MOVLW       _Snake_Y+0
	MOVWF       FSR0L 
	MOVLW       hi_addr(_Snake_Y+0)
	MOVWF       FSR0H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR0L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Display_Y_Select_Y_Var+0 
	CALL        _Display_Y_Select+0, 0
L_Display_UpDate62:
;Snake.c,143 :: 		if(Food_X==6 && Food_Show) Display_Y_Select(Food_Y);
	MOVLW       0
	XORWF       _Food_X+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Display_UpDate187
	MOVLW       6
	XORWF       _Food_X+0, 0 
L__Display_UpDate187:
	BTFSS       STATUS+0, 2 
	GOTO        L_Display_UpDate65
	BTFSS       _Food_Show+0, BitPos(_Food_Show+0) 
	GOTO        L_Display_UpDate65
L__Display_UpDate159:
	MOVF        _Food_Y+0, 0 
	MOVWF       FARG_Display_Y_Select_Y_Var+0 
	CALL        _Display_Y_Select+0, 0
L_Display_UpDate65:
;Snake.c,140 :: 		for(Ring=0;Ring<Snake_Size;Ring++) {
	INCF        _Ring+0, 1 
;Snake.c,144 :: 		}
	GOTO        L_Display_UpDate59
L_Display_UpDate60:
;Snake.c,145 :: 		}else if(!X7) {
	GOTO        L_Display_UpDate66
L_Display_UpDate58:
	BTFSC       LATB+0, 7 
	GOTO        L_Display_UpDate67
;Snake.c,147 :: 		for(Ring=0;Ring<Snake_Size;Ring++) {
	CLRF        _Ring+0 
L_Display_UpDate68:
	MOVF        _Snake_Size+0, 0 
	SUBWF       _Ring+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_Display_UpDate69
;Snake.c,149 :: 		if(Snake_X[Ring]==7) Display_Y_Select(Snake_Y[Ring]);
	MOVLW       _Snake_X+0
	MOVWF       FSR0L 
	MOVLW       hi_addr(_Snake_X+0)
	MOVWF       FSR0H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR0L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	XORLW       7
	BTFSS       STATUS+0, 2 
	GOTO        L_Display_UpDate71
	MOVLW       _Snake_Y+0
	MOVWF       FSR0L 
	MOVLW       hi_addr(_Snake_Y+0)
	MOVWF       FSR0H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR0L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Display_Y_Select_Y_Var+0 
	CALL        _Display_Y_Select+0, 0
L_Display_UpDate71:
;Snake.c,150 :: 		if(Food_X==7 && Food_Show) Display_Y_Select(Food_Y);
	MOVLW       0
	XORWF       _Food_X+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Display_UpDate188
	MOVLW       7
	XORWF       _Food_X+0, 0 
L__Display_UpDate188:
	BTFSS       STATUS+0, 2 
	GOTO        L_Display_UpDate74
	BTFSS       _Food_Show+0, BitPos(_Food_Show+0) 
	GOTO        L_Display_UpDate74
L__Display_UpDate158:
	MOVF        _Food_Y+0, 0 
	MOVWF       FARG_Display_Y_Select_Y_Var+0 
	CALL        _Display_Y_Select+0, 0
L_Display_UpDate74:
;Snake.c,147 :: 		for(Ring=0;Ring<Snake_Size;Ring++) {
	INCF        _Ring+0, 1 
;Snake.c,151 :: 		}
	GOTO        L_Display_UpDate68
L_Display_UpDate69:
;Snake.c,152 :: 		}
L_Display_UpDate67:
L_Display_UpDate66:
L_Display_UpDate57:
L_Display_UpDate48:
L_Display_UpDate39:
L_Display_UpDate30:
L_Display_UpDate21:
L_Display_UpDate12:
;Snake.c,153 :: 		}
L_end_Display_UpDate:
	RETURN      0
; end of _Display_UpDate

_Display_Y_Select:

;Snake.c,155 :: 		void Display_Y_Select(signed char Y_Var) {
;Snake.c,157 :: 		switch(Y_Var) {
	GOTO        L_Display_Y_Select75
;Snake.c,159 :: 		case 0:  Y0=1; break;
L_Display_Y_Select77:
	BSF         LATC+0, 0 
	GOTO        L_Display_Y_Select76
;Snake.c,160 :: 		case 1:  Y1=1; break;
L_Display_Y_Select78:
	BSF         LATC+0, 1 
	GOTO        L_Display_Y_Select76
;Snake.c,161 :: 		case 2:  Y2=1; break;
L_Display_Y_Select79:
	BSF         LATC+0, 2 
	GOTO        L_Display_Y_Select76
;Snake.c,162 :: 		case 3:  Y3=1; break;
L_Display_Y_Select80:
	BSF         LATC+0, 3 
	GOTO        L_Display_Y_Select76
;Snake.c,163 :: 		case 4:  Y4=1; break;
L_Display_Y_Select81:
	BSF         LATC+0, 4 
	GOTO        L_Display_Y_Select76
;Snake.c,164 :: 		case 5:  Y5=1; break;
L_Display_Y_Select82:
	BSF         LATC+0, 5 
	GOTO        L_Display_Y_Select76
;Snake.c,165 :: 		case 6:  Y6=1; break;
L_Display_Y_Select83:
	BSF         LATC+0, 6 
	GOTO        L_Display_Y_Select76
;Snake.c,166 :: 		case 7:  Y7=1; break;
L_Display_Y_Select84:
	BSF         LATC+0, 7 
	GOTO        L_Display_Y_Select76
;Snake.c,167 :: 		case 8:  Y8=1; break;
L_Display_Y_Select85:
	BSF         LATD+0, 0 
	GOTO        L_Display_Y_Select76
;Snake.c,168 :: 		case 9:  Y9=1; break;
L_Display_Y_Select86:
	BSF         LATD+0, 1 
	GOTO        L_Display_Y_Select76
;Snake.c,169 :: 		case 10: YA=1; break;
L_Display_Y_Select87:
	BSF         LATD+0, 2 
	GOTO        L_Display_Y_Select76
;Snake.c,170 :: 		case 11: YB=1; break;
L_Display_Y_Select88:
	BSF         LATD+0, 3 
	GOTO        L_Display_Y_Select76
;Snake.c,171 :: 		case 12: YC=1; break;
L_Display_Y_Select89:
	BSF         LATD+0, 4 
	GOTO        L_Display_Y_Select76
;Snake.c,172 :: 		case 13: YD=1; break;
L_Display_Y_Select90:
	BSF         LATD+0, 5 
	GOTO        L_Display_Y_Select76
;Snake.c,173 :: 		case 14: YE=1; break;
L_Display_Y_Select91:
	BSF         LATD+0, 6 
	GOTO        L_Display_Y_Select76
;Snake.c,174 :: 		case 15: YF=1;
L_Display_Y_Select92:
	BSF         LATD+0, 7 
;Snake.c,175 :: 		}
	GOTO        L_Display_Y_Select76
L_Display_Y_Select75:
	MOVF        FARG_Display_Y_Select_Y_Var+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_Display_Y_Select77
	MOVF        FARG_Display_Y_Select_Y_Var+0, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_Display_Y_Select78
	MOVF        FARG_Display_Y_Select_Y_Var+0, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_Display_Y_Select79
	MOVF        FARG_Display_Y_Select_Y_Var+0, 0 
	XORLW       3
	BTFSC       STATUS+0, 2 
	GOTO        L_Display_Y_Select80
	MOVF        FARG_Display_Y_Select_Y_Var+0, 0 
	XORLW       4
	BTFSC       STATUS+0, 2 
	GOTO        L_Display_Y_Select81
	MOVF        FARG_Display_Y_Select_Y_Var+0, 0 
	XORLW       5
	BTFSC       STATUS+0, 2 
	GOTO        L_Display_Y_Select82
	MOVF        FARG_Display_Y_Select_Y_Var+0, 0 
	XORLW       6
	BTFSC       STATUS+0, 2 
	GOTO        L_Display_Y_Select83
	MOVF        FARG_Display_Y_Select_Y_Var+0, 0 
	XORLW       7
	BTFSC       STATUS+0, 2 
	GOTO        L_Display_Y_Select84
	MOVF        FARG_Display_Y_Select_Y_Var+0, 0 
	XORLW       8
	BTFSC       STATUS+0, 2 
	GOTO        L_Display_Y_Select85
	MOVF        FARG_Display_Y_Select_Y_Var+0, 0 
	XORLW       9
	BTFSC       STATUS+0, 2 
	GOTO        L_Display_Y_Select86
	MOVF        FARG_Display_Y_Select_Y_Var+0, 0 
	XORLW       10
	BTFSC       STATUS+0, 2 
	GOTO        L_Display_Y_Select87
	MOVF        FARG_Display_Y_Select_Y_Var+0, 0 
	XORLW       11
	BTFSC       STATUS+0, 2 
	GOTO        L_Display_Y_Select88
	MOVF        FARG_Display_Y_Select_Y_Var+0, 0 
	XORLW       12
	BTFSC       STATUS+0, 2 
	GOTO        L_Display_Y_Select89
	MOVF        FARG_Display_Y_Select_Y_Var+0, 0 
	XORLW       13
	BTFSC       STATUS+0, 2 
	GOTO        L_Display_Y_Select90
	MOVF        FARG_Display_Y_Select_Y_Var+0, 0 
	XORLW       14
	BTFSC       STATUS+0, 2 
	GOTO        L_Display_Y_Select91
	MOVF        FARG_Display_Y_Select_Y_Var+0, 0 
	XORLW       15
	BTFSC       STATUS+0, 2 
	GOTO        L_Display_Y_Select92
L_Display_Y_Select76:
;Snake.c,176 :: 		}
L_end_Display_Y_Select:
	RETURN      0
; end of _Display_Y_Select

_Snake_UpDate:

;Snake.c,178 :: 		void Snake_UpDate() {
;Snake.c,180 :: 		if(!Pause) {
	BTFSC       _Pause+0, BitPos(_Pause+0) 
	GOTO        L_Snake_UpDate93
;Snake.c,182 :: 		for(Ring=Snake_Size-1;Ring>0;Ring--) {
	DECF        _Snake_Size+0, 0 
	MOVWF       _Ring+0 
L_Snake_UpDate94:
	MOVF        _Ring+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_Snake_UpDate95
;Snake.c,184 :: 		Snake_X[Ring]=Snake_X[Ring-1];
	MOVLW       _Snake_X+0
	MOVWF       FSR1L 
	MOVLW       hi_addr(_Snake_X+0)
	MOVWF       FSR1H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR1L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1H, 1 
	DECF        _Ring+0, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVLW       _Snake_X+0
	ADDWF       R0, 0 
	MOVWF       FSR0L 
	MOVLW       hi_addr(_Snake_X+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;Snake.c,185 :: 		Snake_Y[Ring]=Snake_Y[Ring-1];
	MOVLW       _Snake_Y+0
	MOVWF       FSR1L 
	MOVLW       hi_addr(_Snake_Y+0)
	MOVWF       FSR1H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR1L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1H, 1 
	DECF        _Ring+0, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVLW       _Snake_Y+0
	ADDWF       R0, 0 
	MOVWF       FSR0L 
	MOVLW       hi_addr(_Snake_Y+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;Snake.c,182 :: 		for(Ring=Snake_Size-1;Ring>0;Ring--) {
	DECF        _Ring+0, 1 
;Snake.c,186 :: 		}
	GOTO        L_Snake_UpDate94
L_Snake_UpDate95:
;Snake.c,187 :: 		switch(Vectorial) {
	GOTO        L_Snake_UpDate97
;Snake.c,189 :: 		case UP:    Snake_Y[0]-=1; break;
L_Snake_UpDate99:
	DECF        _Snake_Y+0, 1 
	GOTO        L_Snake_UpDate98
;Snake.c,190 :: 		case Down:  Snake_Y[0]+=1; break;
L_Snake_UpDate100:
	INCF        _Snake_Y+0, 1 
	GOTO        L_Snake_UpDate98
;Snake.c,191 :: 		case RIGHT: Snake_X[0]+=1; break;
L_Snake_UpDate101:
	INCF        _Snake_X+0, 1 
	GOTO        L_Snake_UpDate98
;Snake.c,192 :: 		case LEFT:  Snake_X[0]-=1;
L_Snake_UpDate102:
	DECF        _Snake_X+0, 1 
;Snake.c,193 :: 		}
	GOTO        L_Snake_UpDate98
L_Snake_UpDate97:
	MOVF        _Vectorial+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_Snake_UpDate99
	MOVF        _Vectorial+0, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_Snake_UpDate100
	MOVF        _Vectorial+0, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_Snake_UpDate101
	MOVF        _Vectorial+0, 0 
	XORLW       3
	BTFSC       STATUS+0, 2 
	GOTO        L_Snake_UpDate102
L_Snake_UpDate98:
;Snake.c,194 :: 		if(Snake_X[0]==Food_X && Snake_Y[0]==Food_Y) Snake_Incr();
	MOVLW       0
	BTFSC       _Snake_X+0, 7 
	MOVLW       255
	XORWF       _Food_X+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Snake_UpDate191
	MOVF        _Food_X+0, 0 
	XORWF       _Snake_X+0, 0 
L__Snake_UpDate191:
	BTFSS       STATUS+0, 2 
	GOTO        L_Snake_UpDate105
	MOVLW       0
	BTFSC       _Snake_Y+0, 7 
	MOVLW       255
	XORWF       _Food_Y+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Snake_UpDate192
	MOVF        _Food_Y+0, 0 
	XORWF       _Snake_Y+0, 0 
L__Snake_UpDate192:
	BTFSS       STATUS+0, 2 
	GOTO        L_Snake_UpDate105
L__Snake_UpDate166:
	CALL        _Snake_Incr+0, 0
L_Snake_UpDate105:
;Snake.c,196 :: 		if(Snake_Size==15) Next_Level();
	MOVF        _Snake_Size+0, 0 
	XORLW       15
	BTFSS       STATUS+0, 2 
	GOTO        L_Snake_UpDate106
	CALL        _Next_Level+0, 0
L_Snake_UpDate106:
;Snake.c,198 :: 		Snake_Position_Check();
	CALL        _Snake_Position_Check+0, 0
;Snake.c,199 :: 		Snake_UpDated = 1;
	BSF         _Snake_UpDated+0, BitPos(_Snake_UpDated+0) 
;Snake.c,200 :: 		Beep(10,0,1);
	MOVLW       10
	MOVWF       FARG_Beep_ON_Time+0 
	CLRF        FARG_Beep_OFF_Time+0 
	MOVLW       1
	MOVWF       FARG_Beep_NUM_Time+0 
	CALL        _Beep+0, 0
;Snake.c,201 :: 		}
L_Snake_UpDate93:
;Snake.c,202 :: 		Food_Show= ~Food_Show;
	BTG         _Food_Show+0, BitPos(_Food_Show+0) 
;Snake.c,203 :: 		}
L_end_Snake_UpDate:
	RETURN      0
; end of _Snake_UpDate

_Read_Vectorial_Keys:

;Snake.c,205 :: 		void Read_Vectorial_Keys() {
;Snake.c,207 :: 		if(Snake_UpDated==1 && !Pause) {
	BTFSS       _Snake_UpDated+0, BitPos(_Snake_UpDated+0) 
	GOTO        L_Read_Vectorial_Keys109
	BTFSC       _Pause+0, BitPos(_Pause+0) 
	GOTO        L_Read_Vectorial_Keys109
L__Read_Vectorial_Keys171:
;Snake.c,209 :: 		if(!UP_Key && Vectorial!=DOWN) {
	BTFSC       PORTA+0, 0 
	GOTO        L_Read_Vectorial_Keys112
	MOVF        _Vectorial+0, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_Read_Vectorial_Keys112
L__Read_Vectorial_Keys170:
;Snake.c,211 :: 		Vectorial = UP;
	CLRF        _Vectorial+0 
;Snake.c,212 :: 		Snake_UpDated = 0;
	BCF         _Snake_UpDated+0, BitPos(_Snake_UpDated+0) 
;Snake.c,214 :: 		}else if(!DOWN_Key && Vectorial!=UP) {
	GOTO        L_Read_Vectorial_Keys113
L_Read_Vectorial_Keys112:
	BTFSC       PORTA+0, 1 
	GOTO        L_Read_Vectorial_Keys116
	MOVF        _Vectorial+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_Read_Vectorial_Keys116
L__Read_Vectorial_Keys169:
;Snake.c,216 :: 		Vectorial = DOWN;
	MOVLW       1
	MOVWF       _Vectorial+0 
;Snake.c,217 :: 		Snake_UpDated = 0;
	BCF         _Snake_UpDated+0, BitPos(_Snake_UpDated+0) 
;Snake.c,219 :: 		}else if(!RIGHT_Key && Vectorial!=LEFT) {
	GOTO        L_Read_Vectorial_Keys117
L_Read_Vectorial_Keys116:
	BTFSC       PORTA+0, 2 
	GOTO        L_Read_Vectorial_Keys120
	MOVF        _Vectorial+0, 0 
	XORLW       3
	BTFSC       STATUS+0, 2 
	GOTO        L_Read_Vectorial_Keys120
L__Read_Vectorial_Keys168:
;Snake.c,221 :: 		Vectorial = RIGHT;
	MOVLW       2
	MOVWF       _Vectorial+0 
;Snake.c,222 :: 		Snake_UpDated = 0;
	BCF         _Snake_UpDated+0, BitPos(_Snake_UpDated+0) 
;Snake.c,224 :: 		}else if(!LEFT_Key && Vectorial!=RIGHT) {
	GOTO        L_Read_Vectorial_Keys121
L_Read_Vectorial_Keys120:
	BTFSC       PORTA+0, 3 
	GOTO        L_Read_Vectorial_Keys124
	MOVF        _Vectorial+0, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_Read_Vectorial_Keys124
L__Read_Vectorial_Keys167:
;Snake.c,226 :: 		Vectorial = LEFT;
	MOVLW       3
	MOVWF       _Vectorial+0 
;Snake.c,227 :: 		Snake_UpDated = 0;
	BCF         _Snake_UpDated+0, BitPos(_Snake_UpDated+0) 
;Snake.c,228 :: 		}
L_Read_Vectorial_Keys124:
L_Read_Vectorial_Keys121:
L_Read_Vectorial_Keys117:
L_Read_Vectorial_Keys113:
;Snake.c,229 :: 		}
L_Read_Vectorial_Keys109:
;Snake.c,230 :: 		}
L_end_Read_Vectorial_Keys:
	RETURN      0
; end of _Read_Vectorial_Keys

_Read_Function_Keys:

;Snake.c,232 :: 		void Read_Function_Keys() {
;Snake.c,234 :: 		if(!Turbo_Key) Speed = Level/2;
	BTFSC       PORTA+0, 4 
	GOTO        L_Read_Function_Keys125
	MOVF        _Level+0, 0 
	MOVWF       _Speed+0 
	MOVF        _Level+1, 0 
	MOVWF       _Speed+1 
	RRCF        _Speed+1, 1 
	RRCF        _Speed+0, 1 
	BCF         _Speed+1, 7 
	GOTO        L_Read_Function_Keys126
L_Read_Function_Keys125:
;Snake.c,235 :: 		else Speed = Level;
	MOVF        _Level+0, 0 
	MOVWF       _Speed+0 
	MOVF        _Level+1, 0 
	MOVWF       _Speed+1 
L_Read_Function_Keys126:
;Snake.c,237 :: 		if(!Pause_Key && !Pause_Pressed) {
	BTFSC       PORTA+0, 5 
	GOTO        L_Read_Function_Keys129
	BTFSC       _Pause_Pressed+0, BitPos(_Pause_Pressed+0) 
	GOTO        L_Read_Function_Keys129
L__Read_Function_Keys172:
;Snake.c,239 :: 		Pause_Pressed = 1;
	BSF         _Pause_Pressed+0, BitPos(_Pause_Pressed+0) 
;Snake.c,240 :: 		Pause = ~Pause;
	BTG         _Pause+0, BitPos(_Pause+0) 
;Snake.c,242 :: 		}else if(Pause_Key) Pause_Pressed = 0;
	GOTO        L_Read_Function_Keys130
L_Read_Function_Keys129:
	BTFSS       PORTA+0, 5 
	GOTO        L_Read_Function_Keys131
	BCF         _Pause_Pressed+0, BitPos(_Pause_Pressed+0) 
L_Read_Function_Keys131:
L_Read_Function_Keys130:
;Snake.c,244 :: 		}
L_end_Read_Function_Keys:
	RETURN      0
; end of _Read_Function_Keys

_Beep:

;Snake.c,246 :: 		void Beep(unsigned char ON_Time,unsigned char OFF_Time,unsigned char NUM_Time) {
;Snake.c,248 :: 		for(NUM_Time;NUM_Time>0;NUM_Time--) {
L_Beep132:
	MOVF        FARG_Beep_NUM_Time+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_Beep133
;Snake.c,250 :: 		Buzzer = 1;
	BSF         LATE+0, 0 
;Snake.c,251 :: 		Vdelay_ms(ON_Time);
	MOVF        FARG_Beep_ON_Time+0, 0 
	MOVWF       FARG_VDelay_ms_Time_ms+0 
	MOVLW       0
	MOVWF       FARG_VDelay_ms_Time_ms+1 
	CALL        _VDelay_ms+0, 0
;Snake.c,252 :: 		Buzzer = 0;
	BCF         LATE+0, 0 
;Snake.c,253 :: 		Vdelay_ms(OFF_Time);
	MOVF        FARG_Beep_OFF_Time+0, 0 
	MOVWF       FARG_VDelay_ms_Time_ms+0 
	MOVLW       0
	MOVWF       FARG_VDelay_ms_Time_ms+1 
	CALL        _VDelay_ms+0, 0
;Snake.c,248 :: 		for(NUM_Time;NUM_Time>0;NUM_Time--) {
	DECF        FARG_Beep_NUM_Time+0, 1 
;Snake.c,254 :: 		}
	GOTO        L_Beep132
L_Beep133:
;Snake.c,255 :: 		}
L_end_Beep:
	RETURN      0
; end of _Beep

_Create_Food:

;Snake.c,257 :: 		void Create_Food() {
;Snake.c,259 :: 		do {
L_Create_Food135:
;Snake.c,261 :: 		Food_X = rand()/4096;
	CALL        _rand+0, 0
	MOVLW       12
	MOVWF       R2 
	MOVF        R0, 0 
	MOVWF       _Food_X+0 
	MOVF        R1, 0 
	MOVWF       _Food_X+1 
	MOVF        R2, 0 
L__Create_Food197:
	BZ          L__Create_Food198
	RRCF        _Food_X+1, 1 
	RRCF        _Food_X+0, 1 
	BCF         _Food_X+1, 7 
	BTFSC       _Food_X+1, 6 
	BSF         _Food_X+1, 7 
	ADDLW       255
	GOTO        L__Create_Food197
L__Create_Food198:
;Snake.c,262 :: 		Food_Y = rand()/2048;
	CALL        _rand+0, 0
	MOVLW       11
	MOVWF       R2 
	MOVF        R0, 0 
	MOVWF       _Food_Y+0 
	MOVF        R1, 0 
	MOVWF       _Food_Y+1 
	MOVF        R2, 0 
L__Create_Food199:
	BZ          L__Create_Food200
	RRCF        _Food_Y+1, 1 
	RRCF        _Food_Y+0, 1 
	BCF         _Food_Y+1, 7 
	BTFSC       _Food_Y+1, 6 
	BSF         _Food_Y+1, 7 
	ADDLW       255
	GOTO        L__Create_Food199
L__Create_Food200:
;Snake.c,263 :: 		Food_Error = 0;
	BCF         _Food_Error+0, BitPos(_Food_Error+0) 
;Snake.c,265 :: 		for(Ring=0;Ring<Snake_Size;Ring++) {
	CLRF        _Ring+0 
L_Create_Food138:
	MOVF        _Snake_Size+0, 0 
	SUBWF       _Ring+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_Create_Food139
;Snake.c,267 :: 		if(Food_X==Snake_X[Ring] && Food_Y==Snake_Y[Ring]) {
	MOVLW       _Snake_X+0
	MOVWF       FSR2L 
	MOVLW       hi_addr(_Snake_X+0)
	MOVWF       FSR2H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR2L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR2H, 1 
	MOVF        POSTINC2+0, 0 
	MOVWF       R1 
	MOVLW       0
	BTFSC       R1, 7 
	MOVLW       255
	XORWF       _Food_X+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Create_Food201
	MOVF        R1, 0 
	XORWF       _Food_X+0, 0 
L__Create_Food201:
	BTFSS       STATUS+0, 2 
	GOTO        L_Create_Food143
	MOVLW       _Snake_Y+0
	MOVWF       FSR2L 
	MOVLW       hi_addr(_Snake_Y+0)
	MOVWF       FSR2H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR2L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR2H, 1 
	MOVF        POSTINC2+0, 0 
	MOVWF       R1 
	MOVLW       0
	BTFSC       R1, 7 
	MOVLW       255
	XORWF       _Food_Y+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Create_Food202
	MOVF        R1, 0 
	XORWF       _Food_Y+0, 0 
L__Create_Food202:
	BTFSS       STATUS+0, 2 
	GOTO        L_Create_Food143
L__Create_Food173:
;Snake.c,269 :: 		Food_Error = 1;
	BSF         _Food_Error+0, BitPos(_Food_Error+0) 
;Snake.c,270 :: 		break;
	GOTO        L_Create_Food139
;Snake.c,271 :: 		}
L_Create_Food143:
;Snake.c,265 :: 		for(Ring=0;Ring<Snake_Size;Ring++) {
	INCF        _Ring+0, 1 
;Snake.c,272 :: 		}
	GOTO        L_Create_Food138
L_Create_Food139:
;Snake.c,273 :: 		}while(Food_Error==1);
	BTFSC       _Food_Error+0, BitPos(_Food_Error+0) 
	GOTO        L_Create_Food135
;Snake.c,274 :: 		}
L_end_Create_Food:
	RETURN      0
; end of _Create_Food

_Snake_Incr:

;Snake.c,276 :: 		void Snake_Incr() {
;Snake.c,278 :: 		++Snake_Size;
	INCF        _Snake_Size+0, 1 
;Snake.c,280 :: 		for(Ring=Snake_Size-1;Ring>0;Ring--) {
	DECF        _Snake_Size+0, 0 
	MOVWF       _Ring+0 
L_Snake_Incr144:
	MOVF        _Ring+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_Snake_Incr145
;Snake.c,282 :: 		Snake_X[Ring]=Snake_X[Ring-1];
	MOVLW       _Snake_X+0
	MOVWF       FSR1L 
	MOVLW       hi_addr(_Snake_X+0)
	MOVWF       FSR1H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR1L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1H, 1 
	DECF        _Ring+0, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVLW       _Snake_X+0
	ADDWF       R0, 0 
	MOVWF       FSR0L 
	MOVLW       hi_addr(_Snake_X+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;Snake.c,283 :: 		Snake_Y[Ring]=Snake_Y[Ring-1];
	MOVLW       _Snake_Y+0
	MOVWF       FSR1L 
	MOVLW       hi_addr(_Snake_Y+0)
	MOVWF       FSR1H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR1L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1H, 1 
	DECF        _Ring+0, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVLW       _Snake_Y+0
	ADDWF       R0, 0 
	MOVWF       FSR0L 
	MOVLW       hi_addr(_Snake_Y+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;Snake.c,280 :: 		for(Ring=Snake_Size-1;Ring>0;Ring--) {
	DECF        _Ring+0, 1 
;Snake.c,284 :: 		}
	GOTO        L_Snake_Incr144
L_Snake_Incr145:
;Snake.c,285 :: 		Create_Food();
	CALL        _Create_Food+0, 0
;Snake.c,286 :: 		Beep(10,10,1);
	MOVLW       10
	MOVWF       FARG_Beep_ON_Time+0 
	MOVLW       10
	MOVWF       FARG_Beep_OFF_Time+0 
	MOVLW       1
	MOVWF       FARG_Beep_NUM_Time+0 
	CALL        _Beep+0, 0
;Snake.c,287 :: 		}
L_end_Snake_Incr:
	RETURN      0
; end of _Snake_Incr

_Snake_Position_Check:

;Snake.c,289 :: 		void Snake_Position_Check() {
;Snake.c,291 :: 		if(Snake_X[0]>7 || Snake_X[0]<0 || Snake_Y[0]>15 || Snake_Y[0]<0) {
	MOVLW       128
	XORLW       7
	MOVWF       R0 
	MOVLW       128
	XORWF       _Snake_X+0, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__Snake_Position_Check175
	MOVLW       128
	XORWF       _Snake_X+0, 0 
	MOVWF       R0 
	MOVLW       128
	XORLW       0
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__Snake_Position_Check175
	MOVLW       128
	XORLW       15
	MOVWF       R0 
	MOVLW       128
	XORWF       _Snake_Y+0, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__Snake_Position_Check175
	MOVLW       128
	XORWF       _Snake_Y+0, 0 
	MOVWF       R0 
	MOVLW       128
	XORLW       0
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__Snake_Position_Check175
	GOTO        L_Snake_Position_Check149
L__Snake_Position_Check175:
;Snake.c,293 :: 		Init_Game();
	CALL        _Init_Game+0, 0
;Snake.c,294 :: 		Level = 500;
	MOVLW       244
	MOVWF       _Level+0 
	MOVLW       1
	MOVWF       _Level+1 
;Snake.c,296 :: 		}else {
	GOTO        L_Snake_Position_Check150
L_Snake_Position_Check149:
;Snake.c,298 :: 		for(Ring=2;Ring<Snake_Size;Ring++) {
	MOVLW       2
	MOVWF       _Ring+0 
L_Snake_Position_Check151:
	MOVF        _Snake_Size+0, 0 
	SUBWF       _Ring+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_Snake_Position_Check152
;Snake.c,300 :: 		if(Snake_X[0]==Snake_X[Ring] && Snake_Y[0]==Snake_Y[Ring]) {
	MOVLW       _Snake_X+0
	MOVWF       FSR2L 
	MOVLW       hi_addr(_Snake_X+0)
	MOVWF       FSR2H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR2L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR2H, 1 
	MOVF        _Snake_X+0, 0 
	XORWF       POSTINC2+0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_Snake_Position_Check156
	MOVLW       _Snake_Y+0
	MOVWF       FSR2L 
	MOVLW       hi_addr(_Snake_Y+0)
	MOVWF       FSR2H 
	MOVF        _Ring+0, 0 
	ADDWF       FSR2L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR2H, 1 
	MOVF        _Snake_Y+0, 0 
	XORWF       POSTINC2+0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_Snake_Position_Check156
L__Snake_Position_Check174:
;Snake.c,302 :: 		Init_Game();
	CALL        _Init_Game+0, 0
;Snake.c,303 :: 		Level = 500;
	MOVLW       244
	MOVWF       _Level+0 
	MOVLW       1
	MOVWF       _Level+1 
;Snake.c,304 :: 		}
L_Snake_Position_Check156:
;Snake.c,298 :: 		for(Ring=2;Ring<Snake_Size;Ring++) {
	INCF        _Ring+0, 1 
;Snake.c,305 :: 		}
	GOTO        L_Snake_Position_Check151
L_Snake_Position_Check152:
;Snake.c,306 :: 		}
L_Snake_Position_Check150:
;Snake.c,307 :: 		}
L_end_Snake_Position_Check:
	RETURN      0
; end of _Snake_Position_Check

_Init_Game:

;Snake.c,309 :: 		void Init_Game() {
;Snake.c,311 :: 		Vectorial = DOWN;
	MOVLW       1
	MOVWF       _Vectorial+0 
;Snake.c,312 :: 		Snake_Size = 4;
	MOVLW       4
	MOVWF       _Snake_Size+0 
;Snake.c,314 :: 		Create_Food();
	CALL        _Create_Food+0, 0
;Snake.c,316 :: 		Snake_X[3]=0;
	CLRF        _Snake_X+3 
;Snake.c,317 :: 		Snake_Y[3]=0;
	CLRF        _Snake_Y+3 
;Snake.c,318 :: 		Snake_X[2]=0;
	CLRF        _Snake_X+2 
;Snake.c,319 :: 		Snake_Y[2]=1;
	MOVLW       1
	MOVWF       _Snake_Y+2 
;Snake.c,320 :: 		Snake_X[1]=0;
	CLRF        _Snake_X+1 
;Snake.c,321 :: 		Snake_Y[1]=2;
	MOVLW       2
	MOVWF       _Snake_Y+1 
;Snake.c,322 :: 		Snake_X[0]=0;
	CLRF        _Snake_X+0 
;Snake.c,323 :: 		Snake_Y[0]=3;
	MOVLW       3
	MOVWF       _Snake_Y+0 
;Snake.c,325 :: 		Display_X=254;
	MOVLW       254
	MOVWF       LATB+0 
;Snake.c,327 :: 		Beep(10,10,3);
	MOVLW       10
	MOVWF       FARG_Beep_ON_Time+0 
	MOVLW       10
	MOVWF       FARG_Beep_OFF_Time+0 
	MOVLW       3
	MOVWF       FARG_Beep_NUM_Time+0 
	CALL        _Beep+0, 0
;Snake.c,328 :: 		}
L_end_Init_Game:
	RETURN      0
; end of _Init_Game

_Next_Level:

;Snake.c,330 :: 		void Next_Level() {
;Snake.c,332 :: 		Init_Game();
	CALL        _Init_Game+0, 0
;Snake.c,334 :: 		Level*=0.8;
	MOVF        _Level+0, 0 
	MOVWF       R0 
	MOVF        _Level+1, 0 
	MOVWF       R1 
	CALL        _Word2Double+0, 0
	MOVLW       205
	MOVWF       R4 
	MOVLW       204
	MOVWF       R5 
	MOVLW       76
	MOVWF       R6 
	MOVLW       126
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	CALL        _Double2Word+0, 0
	MOVF        R0, 0 
	MOVWF       _Level+0 
	MOVF        R1, 0 
	MOVWF       _Level+1 
;Snake.c,335 :: 		if(Level<10) Level = 500;
	MOVLW       0
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Next_Level207
	MOVLW       10
	SUBWF       R0, 0 
L__Next_Level207:
	BTFSC       STATUS+0, 0 
	GOTO        L_Next_Level157
	MOVLW       244
	MOVWF       _Level+0 
	MOVLW       1
	MOVWF       _Level+1 
L_Next_Level157:
;Snake.c,337 :: 		Beep(50,50,4);
	MOVLW       50
	MOVWF       FARG_Beep_ON_Time+0 
	MOVLW       50
	MOVWF       FARG_Beep_OFF_Time+0 
	MOVLW       4
	MOVWF       FARG_Beep_NUM_Time+0 
	CALL        _Beep+0, 0
;Snake.c,338 :: 		}
L_end_Next_Level:
	RETURN      0
; end of _Next_Level
